/* crc32a.c by Craig Bruce, 26-Feb-93 */

#include <stdio.h>

#define CRC32_GEN	0x04c11db7  /* CCITT standard */
#define CRC32_MSB	0x80000000

unsigned long getcrc();

/******************************************************************************/
main( argc, argv )
	int argc;
	char *argv[];
{
	int i;
	FILE *fp;
	unsigned long crc;

	if (argc < 2) {
		crc = getcrc( stdin );
		printf("crc32a = %10lu for <stdin>\n", crc);
	} else {
		for (i=1; i<argc; i++) {
			if ( (fp=fopen(argv[i],"rb")) == NULL ) {
				printf("error opening file \"%s\"!\n", argv[i]);
			} else {
				crc = getcrc( fp );
				printf("crc32a = %10lu for \"%s\"\n",
					crc, argv[i]);
				fclose( fp );
			}
		}
	}
}

/******************************************************************************/
unsigned long getcrc( fp )
	FILE *fp;
{
	register unsigned long crcbin, crcOverflow;
	int c, i;

	crcbin = 0;
	while( (c=getc(fp)) != EOF ) {
		for (i=0x80; i; i >>= 1) {
			crcOverflow = crcbin & CRC32_MSB;
			crcbin = (crcbin << 1) | (i&c ? 1 : 0);
			if (crcOverflow) crcbin ^= CRC32_GEN;
		}
	}
	return( crcbin );
}
